MAX_MODULES = 31

#-----------------------------------------------------------------------
# new PCube Module States
#-----------------------------------------------------------------------
STATEID_MOD_ERROR	 = 	0x00000001L
STATEID_MOD_HOME	 = 	0x00000002L
STATEID_MOD_HALT	 = 	0x00000004L
STATEID_MOD_POWERFAULT	 =  	0x00000008L
STATEID_MOD_TOW_ERROR	 =  	0x00000010L
STATEID_MOD_COMM_ERROR	 = 	0x00000020L
STATEID_MOD_SWR		 = 	0x00000040L
STATEID_MOD_SW1		 = 	0x00000080L
STATEID_MOD_SW2		 = 	0x00000100L
STATEID_MOD_BRAKEACTIVE  = 	0x00000200L
STATEID_MOD_CURLIMIT	 = 	0x00000400L
STATEID_MOD_MOTION	 = 	0x00000800L
STATEID_MOD_RAMP_ACC	 = 	0x00001000L
STATEID_MOD_RAMP_STEADY	 = 	0x00002000L
STATEID_MOD_RAMP_DEC	 = 	0x00004000L
STATEID_MOD_RAMP_END	 = 	0x00008000L
STATEID_MOD_INPROGRESS	 = 	0x00010000L
STATEID_MOD_FULLBUFFER	 = 	0x00020000L
STATEID_MOD_POW_VOLT_ERR = 	0x00040000L
STATEID_MOD_POW_FET_TEMP = 	0x00080000L
STATEID_MOD_POW_WDG_TEMP = 	0x00100000L
STATEID_MOD_POW_SHORTCUR = 	0x00200000L
STATEID_MOD_POW_HALLERR	 = 	0x00400000L
STATEID_MOD_POW_INTEGRALERR = 	0x00800000L
STATEID_MOD_CPU_OVERLOAD = 	0x01000000L
STATEID_MOD_BEYOND_HARD	 = 	0x02000000L
STATEID_MOD_BEYOND_SOFT	 = 	0x04000000L

#-----------------------------------------------------------------------
# new PCube Module Config
#-----------------------------------------------------------------------
CONFIGID_MOD_ENCODER_FEEDBACK	 = 		0x00000001L #OS: 25xx from 35xx in SETUP
CONFIGID_MOD_RESOLVER_FEEDBACK	 = 	        0x00000002L #OS: 25xx from 35xx in SETUP
CONFIGID_MOD_ABSOLUTE_FEEDBACK	 = 		0x00000004L #OS: 25xx from 35xx in SETUP
CONFIGID_MOD_BRAKE_PRESENT	 = 		0x00000008L
CONFIGID_MOD_BRAKE_AT_POWERON	 = 		0x00000010L
CONFIGID_MOD_SWR_WITH_ENCODERZERO = 		0x00000020L
CONFIGID_MOD_SWR_AT_FALLING_EDGE = 		0x00000040L
CONFIGID_MOD_CHANGE_SWR_TO_LIMIT = 		0x00000080L
CONFIGID_MOD_SWR_ENABLED         = 		0x00000100L
CONFIGID_MOD_SWR_LOW_ACTIVE	 = 		0x00000200L
CONFIGID_MOD_SWR_EQ_POSLIMIT	 = 		0x00000400L #OS: 25xx
CONFIGID_MOD_SWR_USE_EXTERNAL	 = 		0x00000400L #OS: 35xx
CONFIGID_MOD_SW1_ENABLED	 = 		0x00000800L
CONFIGID_MOD_SW1_LOW_ACTIVE	 = 		0x00001000L
CONFIGID_MOD_SW1_EQ_POSLIMIT	 = 		0x00002000L #OS: 25xx
CONFIGID_MOD_SW1_USE_EXTERNAL	 = 		0x00002000L #OS: 35xx
CONFIGID_MOD_SW2_ENABLED	 = 		0x00004000L
CONFIGID_MOD_SW2_LOW_ACTIVE	 = 		0x00008000L
CONFIGID_MOD_SW2_EQ_POSLIMIT	 = 		0x00010000L #OS: 25xx
CONFIGID_MOD_SW2_USE_EXTERNAL	 = 		0x00010000L #OS: 35xx
CONFIGID_MOD_LINEAR		 = 		0x00020000L
CONFIGID_MOD_OPENBRAKE_ON_SW2	 = 		0x00040000L #OS: 25xx but not in 2512 from 35xx in SETUP
CONFIGID_MOD_ALLOW_FULL_CUR	 = 		0x00080000L
CONFIGID_MOD_M3_COMPATIBLE	 = 		0x00100000L
CONFIGID_MOD_LINEAR_SCREW	 = 		0x00200000L
CONFIGID_MOD_DISABLE_ON_HALT	 = 		0x00800000L
CONFIGID_MOD_WATCHDOG_ENABLE	 = 		0x01000000L
CONFIGID_MOD_ZERO_MOVE_AFTER_HOK = 		0x02000000L #OS: 35xx
CONFIGID_MOD_DISABLE_ACK	 = 		0x04000000L
CONFIGID_MOD_SYNC_MOTION	 = 		0x08000000L
CONFIGID_MOD_SYNC_TRANSMIT	 = 		0x10000000L #OS: 36xx
CONFIGID_MOD_CAN_RS232_COMM	 = 		0x40000000L #OS: 25xx
CONFIGID_MOD_PROFI_RS485_COMM	 = 		0x80000000L #OS: 25xx

#-----------------------------------------------------------------------
# new PCube Module Setup
#-----------------------------------------------------------------------
# ---- FEEDBACK SETUP -----------
SETUPID_MOD_ENCODER_FEEDBACK	 = 		0x00000001L
SETUPID_MOD_RESOLVER_FEEDBACK	 = 		0x00000002L
SETUPID_MOD_ABSOLUTE_FEEDBACK	 = 		0x00000004L
# ---- DIGITAL IO SETUP ---------
SETUPID_MOD_4IN_4OUT		 = 		0x00000008L
SETUPID_MOD_3IN_ENCODER_IN	 = 		0x00000010L
SETUPID_MOD_3IN_ENCODER_OUT	 = 		0x00000020L
# ---- COMM INTERFACE -----------
SETUPID_MOD_RS232		 = 		0x00000040L
SETUPID_MOD_CAN			 = 		0x00000200L
SETUPID_MOD_PROFIBUS		 = 		0x00000400L
# ---- CAN ID SETUP -------------
SETUPID_MOD_USE_M3ID		 = 		0x00000800L
SETUPID_MOD_USE_M4ID		 = 		0x00001000L
SETUPID_MOD_USE_CANOPEN		 = 		0x00002000L
# ---- MOTOR SETUP --------------
SETUPID_MOD_INVERT_MOTORDIR	 = 		0x00004000L
# ---- INPUT USAGE --------------
SETUPID_MOD_USE_SW2_AS_ENABLE	 = 		0x00008000L
SETUPID_MOD_USE_SW2_AS_BRAKE	 = 		0x00010000L
# ---- OUTPUT USAGE -------------
SETUPID_MOD_ERROR_TO_OUT0	 = 		0x00020000L
# ---- IN/OUTPUT USAGE -------------
SETUPID_MOD_IO_GRIPPER_CONTROL	 = 		0x00080000L

#-----------------------------------------------------------------------
# new PCube Module Types
#-----------------------------------------------------------------------
TYPEID_MOD_ROTARY		 = 		0x0f
TYPEID_MOD_LINEAR		 = 		0xf0

#-----------------------------------------------------------------------
# new PCube Module DIO's
#-----------------------------------------------------------------------
DIOID_MOD_INBIT0		 = 		0x00000001L
DIOID_MOD_INBIT1		 = 		0x00000002L
DIOID_MOD_INBIT2		 = 		0x00000004L
DIOID_MOD_INBIT3		 = 		0x00000008L
 
DIOID_MOD_OUTBIT0		 = 		0x00000010L
DIOID_MOD_OUTBIT1		 = 		0x00000020L
DIOID_MOD_OUTBIT2		 = 		0x00000040L
DIOID_MOD_OUTBIT3		 = 		0x00000080L
 
DIOID_MOD_INSWR			 = 		0x00000100L
DIOID_MOD_INSW1			 = 		0x00000200L
DIOID_MOD_INSW2			 = 		0x00000400L

#-----------------------------------------------------------------------
# new EMS Module Types
#-----------------------------------------------------------------------
TYPEID_EMS_DIG24V_OUT		 = 		10
TYPEID_EMS_DIG24V_IN		 = 		11
TYPEID_EMS_ANA10V_OUT		 = 		12
TYPEID_EMS_ANA10V_IN		 = 		13
TYPEID_EMS_ANA25MA_OUT		 = 		14
TYPEID_EMS_ANA25MA_IN		 = 		15

#-----------------------------------------------------------------------
# new PCube Module Baudrates
#-----------------------------------------------------------------------
BAUDRATEID_MOD_CAN_75K		 = 		0
BAUDRATEID_MOD_CAN_250K		 = 		1
BAUDRATEID_MOD_CAN_500K		 = 		2
BAUDRATEID_MOD_CAN_1000K	 = 		3

BAUDRATEID_MOD_RS232_1200	 = 		0
BAUDRATEID_MOD_RS232_2400	 = 		1
BAUDRATEID_MOD_RS232_4800	 = 		2
BAUDRATEID_MOD_RS232_9600	 = 		3
BAUDRATEID_MOD_RS232_19200	 = 		4
BAUDRATEID_MOD_RS232_38400	 = 		5

#-----------------------------------------------------------------------
# new PCube Device Error Codes
#-----------------------------------------------------------------------
ERRID_DEV			 = 		(-200L)
ERRID_DEV_FUNCTIONNOTAVAILABLE   = 	        (ERRID_DEV - 1)	
ERRID_DEV_NOINITSTRING		 = 		(ERRID_DEV - 2)
ERRID_DEV_NODEVICENAME		 = 		(ERRID_DEV - 3)
ERRID_DEV_BADINITSTRING		 = 		(ERRID_DEV - 4)
ERRID_DEV_INITERROR		 = 		(ERRID_DEV - 5)
ERRID_DEV_NOTINITIALIZED	 = 		(ERRID_DEV - 6)
ERRID_DEV_WRITEERROR		 = 		(ERRID_DEV - 7)
ERRID_DEV_READERROR		 = 		(ERRID_DEV - 8)
ERRID_DEV_WRITETIMEOUT		 = 		(ERRID_DEV - 9)
ERRID_DEV_READTIMEOUT		 = 		(ERRID_DEV - 10)
ERRID_DEV_WRONGMESSAGEID	 = 		(ERRID_DEV - 11)
ERRID_DEV_WRONGCOMMANDID	 = 		(ERRID_DEV - 12)
ERRID_DEV_WRONGPARAMETERID	 = 		(ERRID_DEV - 13)
ERRID_DEV_EXITERROR		 = 		(ERRID_DEV - 14)
ERRID_DEV_NOMODULES		 = 		(ERRID_DEV - 15)
ERRID_DEV_WRONGDEVICEID		 = 		(ERRID_DEV - 16)
ERRID_DEV_NOLIBRARY		 = 		(ERRID_DEV - 17)
ERRID_DEV_ISINITIALIZED		 = 		(ERRID_DEV - 18)
ERRID_DEV_WRONGEMSMODULEID	 = 		(ERRID_DEV - 19)
ERRID_DEV_EMSNOTINITIALIZED	 = 		(ERRID_DEV - 20)
ERRID_DEV_EMSMAXNUMBER		 = 		(ERRID_DEV - 21)
ERRID_DEV_EMSINITERROR		 = 		(ERRID_DEV - 22)
ERRID_DEV_WRONGEMSTYPE		 = 		(ERRID_DEV - 23)
ERRID_DEV_WRONGEMSCHANNELID	 = 		(ERRID_DEV - 24)
ERRID_DEV_WRONGMP55MODULEID	 = 		(ERRID_DEV - 25)
ERRID_DEV_WRONGSCHUNKMODULEID	 = 	        (ERRID_DEV - 26)
ERRID_DEV_WRONGMODULEID		 = 	        (ERRID_DEV - 27)
ERRID_DEV_MODULEERROR		 = 		(ERRID_DEV - 28)
ERRID_DEV_WAITTIMEOUT		 = 		(ERRID_DEV - 29)
