Attribute VB_Name = "M5APIW32"
' file m5apiw32.bas
' for DLL version 5050

Global Const MAX_MODULES = 31

'-----------------------------------------------------------------------
' new PCube Module States
'-----------------------------------------------------------------------
Global Const STATEID_MOD_ERROR = &H1
Global Const STATEID_MOD_HOME = &H2
Global Const STATEID_MOD_HALT = &H4
Global Const STATEID_MOD_POWERFAULT = &H8
Global Const STATEID_MOD_TOW_ERROR = &H10
Global Const STATEID_MOD_COMM_ERROR = &H20
Global Const STATEID_MOD_SWR = &H40
Global Const STATEID_MOD_SW1 = &H80
Global Const STATEID_MOD_SW2 = &H100
Global Const STATEID_MOD_BRAKEACTIVE = &H200
Global Const STATEID_MOD_CURLIMIT = &H400
Global Const STATEID_MOD_MOTION = &H800
Global Const STATEID_MOD_RAMP_ACC = &H1000
Global Const STATEID_MOD_RAMP_STEADY = &H2000
Global Const STATEID_MOD_RAMP_DEC = &H4000
Global Const STATEID_MOD_RAMP_END = &H8000
Global Const STATEID_MOD_INPROGRESS = &H10000
Global Const STATEID_MOD_FULLBUFFER = &H20000
Global Const STATEID_MOD_POW_VOLT_ERR = &H40000
Global Const STATEID_MOD_POW_FET_TEMP = &H80000
Global Const STATEID_MOD_POW_WDG_TEMP = &H100000
Global Const STATEID_MOD_POW_SHORTCUR = &H200000
Global Const STATEID_MOD_POW_HALLERR = &H400000
Global Const STATEID_MOD_POW_INTEGRALERR = &H800000
Global Const STATEID_MOD_CPU_OVERLOAD = &H1000000
Global Const STATEID_MOD_BEYOND_HARD = &H2000000
Global Const STATEID_MOD_BEYOND_SOFT = &H4000000

'-----------------------------------------------------------------------
' new PCube Module Config
'-----------------------------------------------------------------------
Global Const CONFIGID_MOD_ENCODER_FEEDBACK = &H1        'OS: 25xx from 35xx in SETUP
Global Const CONFIGID_MOD_RESOLVER_FEEDBACK = &H2        'OS: 25xx from 35xx in SETUP
Global Const CONFIGID_MOD_ABSOLUTE_FEEDBACK = &H4        'OS: 25xx from 35xx in SETUP
Global Const CONFIGID_MOD_BRAKE_PRESENT = &H8
Global Const CONFIGID_MOD_BRAKE_AT_POWERON = &H10
Global Const CONFIGID_MOD_SWR_WITH_ENCODERZERO = &H20
Global Const CONFIGID_MOD_SWR_AT_FALLING_EDGE = &H40
Global Const CONFIGID_MOD_CHANGE_SWR_TO_LIMIT = &H80
Global Const CONFIGID_MOD_SWR_ENABLED = &H100
Global Const CONFIGID_MOD_SWR_LOW_ACTIVE = &H200
Global Const CONFIGID_MOD_SWR_EQ_POSLIMIT = &H400      'OS: 25xx
Global Const CONFIGID_MOD_SWR_USE_EXTERNAL = &H400      'OS: 35xx
Global Const CONFIGID_MOD_SW1_ENABLED = &H800
Global Const CONFIGID_MOD_SW1_LOW_ACTIVE = &H1000
Global Const CONFIGID_MOD_SW1_EQ_POSLIMIT = &H2000     'OS: 25xx
Global Const CONFIGID_MOD_SW1_USE_EXTERNAL = &H2000     'OS: 35xx
Global Const CONFIGID_MOD_SW2_ENABLED = &H4000
Global Const CONFIGID_MOD_SW2_LOW_ACTIVE = &H8000
Global Const CONFIGID_MOD_SW2_EQ_POSLIMIT = &H10000    'OS: 25xx
Global Const CONFIGID_MOD_SW2_USE_EXTERNAL = &H10000    'OS: 35xx
Global Const CONFIGID_MOD_LINEAR = &H20000
Global Const CONFIGID_MOD_OPENBRAKE_ON_SW2 = &H40000    'OS: 25xx but not in 2512 from 35xx in SETUP
Global Const CONFIGID_MOD_ALLOW_FULL_CUR = &H80000
Global Const CONFIGID_MOD_M3_COMPATIBLE = &H100000
Global Const CONFIGID_MOD_LINEAR_SCREW = &H200000
Global Const CONFIGID_MOD_DISABLE_ON_HALT = &H800000
Global Const CONFIGID_MOD_WATCHDOG_ENABLE = &H1000000
Global Const CONFIGID_MOD_ZERO_MOVE_AFTER_HOK = &H2000000  'OS: 35xx
Global Const CONFIGID_MOD_DISABLE_ACK = &H4000000
Global Const CONFIGID_MOD_SYNC_MOTION = &H8000000
Global Const CONFIGID_MOD_SYNC_TRANSMIT = &H10000000  'OS: 36xx
Global Const CONFIGID_MOD_CAN_RS232_COMM = &H40000000 'OS: 25xx
Global Const CONFIGID_MOD_PROFI_RS485_COMM = &H80000000 'OS: 25xx

'-----------------------------------------------------------------------
' new PCube Module Setup
'-----------------------------------------------------------------------
' ---- FEEDBACK SETUP -----------
Global Const SETUPID_MOD_ENCODER_FEEDBACK = &H1
Global Const SETUPID_MOD_RESOLVER_FEEDBACK = &H2
Global Const SETUPID_MOD_ABSOLUTE_FEEDBACK = &H4
' ---- DIGITAL IO SETUP ---------
Global Const SETUPID_MOD_4IN_4OUT = &H8
Global Const SETUPID_MOD_3IN_ENCODER_IN = &H10
Global Const SETUPID_MOD_3IN_ENCODER_OUT = &H20
' ---- COMM INTERFACE -----------
Global Const SETUPID_MOD_RS232 = &H40
Global Const SETUPID_MOD_CAN = &H200
Global Const SETUPID_MOD_PROFIBUS = &H400
' ---- CAN ID SETUP -------------
Global Const SETUPID_MOD_USE_M3ID = &H800
Global Const SETUPID_MOD_USE_M4ID = &H1000
Global Const SETUPID_MOD_USE_CANOPEN = &H2000
' ---- MOTOR SETUP --------------
Global Const SETUPID_MOD_INVERT_MOTORDIR = &H4000
' ---- INPUT USAGE --------------
Global Const SETUPID_MOD_USE_SW2_AS_ENABLE = &H8000
Global Const SETUPID_MOD_USE_SW2_AS_BRAKE = &H10000
' ---- OUTPUT USAGE -------------
Global Const SETUPID_MOD_ERROR_TO_OUT0 = &H20000
' ---- INPUT/OUTPUT USAGE -------------
Global Const SETUPID_MOD_IO_GRIPPER_CONTROL = &H80000

'-----------------------------------------------------------------------
' new PCube Module Types
'-----------------------------------------------------------------------
Global Const TYPEID_MOD_ROTARY = &HF
Global Const TYPEID_MOD_LINEAR = &HF0

'-----------------------------------------------------------------------
' new PCube Module DIO's
'-----------------------------------------------------------------------
Global Const DIOID_MOD_INBIT0 = &H1
Global Const DIOID_MOD_INBIT1 = &H2
Global Const DIOID_MOD_INBIT2 = &H4
Global Const DIOID_MOD_INBIT3 = &H8
 
Global Const DIOID_MOD_OUTBIT0 = &H10
Global Const DIOID_MOD_OUTBIT1 = &H20
Global Const DIOID_MOD_OUTBIT2 = &H40
Global Const DIOID_MOD_OUTBIT3 = &H80
 
Global Const DIOID_MOD_INSWR = &H100
Global Const DIOID_MOD_INSW1 = &H200
Global Const DIOID_MOD_INSW2 = &H400

'-----------------------------------------------------------------------
' new EMS Module Types
'-----------------------------------------------------------------------
Global Const TYPEID_EMS_DIG24V_OUT = 10
Global Const TYPEID_EMS_DIG24V_IN = 11
Global Const TYPEID_EMS_ANA10V_OUT = 12
Global Const TYPEID_EMS_ANA10V_IN = 13
Global Const TYPEID_EMS_ANA25MA_OUT = 14
Global Const TYPEID_EMS_ANA25MA_IN = 15

'-----------------------------------------------------------------------
' new PCube Module Baudrates
'-----------------------------------------------------------------------
Global Const BAUDRATEID_MOD_CAN_75K = 0
Global Const BAUDRATEID_MOD_CAN_250K = 1
Global Const BAUDRATEID_MOD_CAN_500K = 2
Global Const BAUDRATEID_MOD_CAN_1000K = 3

Global Const BAUDRATEID_MOD_RS232_1200 = 0
Global Const BAUDRATEID_MOD_RS232_2400 = 1
Global Const BAUDRATEID_MOD_RS232_4800 = 2
Global Const BAUDRATEID_MOD_RS232_9600 = 3
Global Const BAUDRATEID_MOD_RS232_19200 = 4
Global Const BAUDRATEID_MOD_RS232_38400 = 5

'-----------------------------------------------------------------------
' new PCube Device Error Codes
' -----------------------------------------------------------------------
Global Const ERRID_DEV = (-200)
Global Const ERRID_DEV_FUNCTIONNOTAVAILABLE = (ERRID_DEV - 1)
Global Const ERRID_DEV_NOINITSTRING = (ERRID_DEV - 2)
Global Const ERRID_DEV_NODEVICENAME = (ERRID_DEV - 3)
Global Const ERRID_DEV_BADINITSTRING = (ERRID_DEV - 4)
Global Const ERRID_DEV_INITERROR = (ERRID_DEV - 5)
Global Const ERRID_DEV_NOTINITIALIZED = (ERRID_DEV - 6)
Global Const ERRID_DEV_WRITEERROR = (ERRID_DEV - 7)
Global Const ERRID_DEV_READERROR = (ERRID_DEV - 8)
Global Const ERRID_DEV_WRITETIMEOUT = (ERRID_DEV - 9)
Global Const ERRID_DEV_READTIMEOUT = (ERRID_DEV - 10)
Global Const ERRID_DEV_WRONGMESSAGEID = (ERRID_DEV - 11)
Global Const ERRID_DEV_WRONGCOMMANDID = (ERRID_DEV - 12)
Global Const ERRID_DEV_WRONGPARAMETERID = (ERRID_DEV - 13)
Global Const ERRID_DEV_EXITERROR = (ERRID_DEV - 14)
Global Const ERRID_DEV_NOMODULES = (ERRID_DEV - 15)
Global Const ERRID_DEV_WRONGDEVICEID = (ERRID_DEV - 16)
Global Const ERRID_DEV_NOLIBRARY = (ERRID_DEV - 17)
Global Const ERRID_DEV_ISINITIALIZED = (ERRID_DEV - 18)
Global Const ERRID_DEV_WRONGEMSMODULEID = (ERRID_DEV - 19)
Global Const ERRID_DEV_EMSNOTINITIALIZED = (ERRID_DEV - 20)
Global Const ERRID_DEV_EMSMAXNUMBER = (ERRID_DEV - 21)
Global Const ERRID_DEV_EMSINITERROR = (ERRID_DEV - 22)
Global Const ERRID_DEV_WRONGEMSTYPE = (ERRID_DEV - 23)
Global Const ERRID_DEV_WRONGEMSCHANNELID = (ERRID_DEV - 24)
Global Const ERRID_DEV_WRONGMP55MODULEID = (ERRID_DEV - 25)
Global Const ERRID_DEV_WRONGSCHUNKMODULEID = (ERRID_DEV - 26)
Global Const ERRID_DEV_WRONGMODULEID = (ERRID_DEV - 27)
Global Const ERRID_DEV_MODULEERROR = (ERRID_DEV - 28)
Global Const ERRID_DEV_WAITTIMEOUT = (ERRID_DEV - 29)

'-----------------------------------------------------------------------
' PCube function declarations
' -----------------------------------------------------------------------
Declare Function PCube_getDllVersion& Lib "m5apiw32.dll" ()
Declare Function PCube_setDllDebug& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)

Declare Function PCube_configFromFile& Lib "m5apiw32.dll" (ByVal x1$)
Declare Function PCube_openDevice& Lib "m5apiw32.dll" (x1&, ByVal x2$)
Declare Function PCube_closeDevice& Lib "m5apiw32.dll" (ByVal x1&)
Declare Function PCube_closeDevices& Lib "m5apiw32.dll" ()
Declare Function PCube_getDeviceCount& Lib "m5apiw32.dll" ()
Declare Function PCube_getDeviceIdMap& Lib "m5apiw32.dll" (x1&)
Declare Function PCube_setDeviceName& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2$)
Declare Function PCube_setDeviceDebug& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&, ByVal x4&)

Declare Function PCube_getModuleCount& Lib "m5apiw32.dll" (ByVal x1&)
Declare Function PCube_getModuleIdMap& Lib "m5apiw32.dll" (ByVal x1&, x2&)
Declare Function PCube_getModuleState& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getModuleType& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3$)
Declare Function PCube_getModuleVersion& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3%)
Declare Function PCube_getModuleSerialNo& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getDefConfig& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getDefSetup& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getDefBaudRate& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3$)
Declare Function PCube_getDefBurnCount& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3$)
Declare Function PCube_getDefGearRatio& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDefLinearRatio& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDefCurRatio& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDefBrakeTimeOut& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3%)
Declare Function PCube_getDefIncPerTurn& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getDefDioData& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getDefA0& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3%)
Declare Function PCube_getDefC0& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3%)
Declare Function PCube_getDefDamp& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3%)
Declare Function PCube_getDefHomeOffset& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDefHomeVel& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDefMinPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDefMaxPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDefMaxVel& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDefMaxAcc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDefMaxCur& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDefMaxDeltaPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)

Declare Function PCube_getConfig& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getIncRatio& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getStateDioPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&, ByVal x4$, x5!)
Declare Function PCube_getDioData& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getA0& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3%)
Declare Function PCube_getC0& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3%)
Declare Function PCube_getDamp& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3%)
Declare Function PCube_getHomeOffset& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getHomeOffsetInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getHomeVel& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getHomeVelInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getPosInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getPosCountInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getVel& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getVelInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getIPolVel& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getCur& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getCurInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3%)
Declare Function PCube_getMinPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getMinPosInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getMaxPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getMaxPosInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getMaxVel& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getMaxVelInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getMaxAcc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getMaxAccInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getMaxCur& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDeltaPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getDeltaPosInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getMaxDeltaPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getMaxDeltaPosInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_getSavePos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_getSyncTime& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3%)

Declare Function PCube_setConfig& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_setDioData& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_setA0& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3%)
Declare Function PCube_setC0& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3%)
Declare Function PCube_setDamp& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3%)
Declare Function PCube_setHomeOffset& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_setHomeOffsetInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_setHomeVel& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_setHomeVelInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_setRampVel& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_setRampVelInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_setRampAcc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_setRampAccInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_setMinPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_setMinPosInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_setMaxPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_setMaxPosInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_setMaxVel& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_setMaxVelInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_setMaxAcc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_setMaxAccInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_setMaxCur& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_setMaxDeltaPos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_setMaxDeltaPosInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_setSyncTime& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3%)

Declare Function PCube_homeModule& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&)
Declare Function PCube_haltModule& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&)
Declare Function PCube_resetModule& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&)
Declare Function PCube_recalcPIDParams& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&)

Declare Function PCube_movePos& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_movePosInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_movePosExtended& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!, x4&, ByVal x5$, x6!)
Declare Function PCube_moveRamp& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!, ByVal x4!, ByVal x5!)
Declare Function PCube_moveRampInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&, ByVal x4&, ByVal x5&)
Declare Function PCube_moveRampExtended& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!, ByVal x4!, ByVal x5!, x6&, ByVal x7$, x8!)
Declare Function PCube_moveVel& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_moveVelInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_moveVelExtended& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!, x4&, ByVal x5$, x6!)
Declare Function PCube_moveCur& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
Declare Function PCube_moveCurInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_moveCurExtended& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!, x4&, ByVal x5$, x6!)
Declare Function PCube_moveStep& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!, ByVal x4%)
Declare Function PCube_moveStepInc& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&, ByVal x4%)
Declare Function PCube_moveStepExtended& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!, ByVal x4%, x5&, ByVal x6$, x7!)

Declare Function PCube_homeAll& Lib "m5apiw32.dll" (ByVal x1&)
Declare Function PCube_resetAll& Lib "m5apiw32.dll" (ByVal x1&)
Declare Function PCube_haltAll& Lib "m5apiw32.dll" (ByVal x1&)
Declare Function PCube_serveWatchdogAll& Lib "m5apiw32.dll" (ByVal x1&)
Declare Function PCube_setBaudRateAll& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2 As Byte)
Declare Function PCube_startMotionAll& Lib "m5apiw32.dll" (ByVal x1&)
Declare Function PCube_savePosAll& Lib "m5apiw32.dll" (ByVal x1&)

Declare Function PCube_waitForHomeEnd& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_waitForMotionEnd& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_waitForRampEnd& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_waitForRampDec& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_waitForRampSteady& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&)
Declare Function PCube_waitForHomeEndAll& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&)
Declare Function PCube_waitForMotionEndAll& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&)
Declare Function PCube_waitForRampEndAll& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&)
Declare Function PCube_waitForStartMotionAll& Lib "m5apiw32.dll" (ByVal x1&)

Declare Function PCube_xmit8Bytes& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3 As Any)
Declare Function PCube_xack8Bytes& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3 As Any)
Declare Function PCube_doInternal& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3 As Any)
Declare Function PCube_getStateInternal& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3&)
Declare Function PCube_updateModuleIdMap& Lib "m5apiw32.dll" (ByVal x1&)

Declare Function PCube_initEMS_IO& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2 As Byte, ByVal x3&)
Declare Function PCube_getDataEMS_DIO& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&, x4&)
Declare Function PCube_getDataEMS_AIO& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&, x4!)
Declare Function PCube_setDataEMS_DIO& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&, ByVal x4&)
Declare Function PCube_setDataEMS_AIO& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&, ByVal x4!)

Declare Function PCube_initDLR_FTS& Lib "m5apiw32.dll" (ByVal x1&)
Declare Function PCube_getDataDLR_FTS& Lib "m5apiw32.dll" (ByVal x1&, x2!, x3!, x4!, x5!, x6!, x7!, x8&)

Declare Function PCube_getDataSCHUNK_FTC& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3&, x4!, x5!, x6!, x7!, x8!, x9!, x10%)
Declare Function PCube_setNullSCHUNK_FTC& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3%)

Declare Function PCube_getDataMP55_IO& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, x3!)
Declare Function PCube_setTaraMP55_IO& Lib "m5apiw32.dll" (ByVal x1&, ByVal x2&, ByVal x3!)
