#include<iostream>
#include<cstdlib>
#include<cstdio>
#include<fstream>
#include<cmath>

#define MIN(x,y) (x<y?x:y)
#define MAX(x,y) (x<y?x:y)

using namespace std;

//====================================================================
double** allocate(int m, int n)
{

  double **a;

  a = new double *[m];
  for(int i = 0;i<m;i++)
    a[i] = new double [n];
  return (a);
}
//====================================================================
double* allocate(int n)
{
  double *a;
  a = new double [n];
  return (a);
}
//====================================================================
void randomize(double **a, int m, int n, double range)
{


  srand(time(NULL));
  for(int i = 0; i<m; i++)
    for(int j = 0; j<n; j++)
      a[i][j] = range * (2*(double)rand()/RAND_MAX - 1);

  return ;
}
//====================================================================
void randomize(double *a, int n, double range)
{

  srand(time(NULL));
  for(int i = 0; i<n; i++)
    a[i] = range * (2*(double)rand()/RAND_MAX -1);

  return ;
}
//====================================================================
void eye(double **a, int n)
{

  for(int i = 0;i<n;i++)
    for(int j = 0;j<n;j++)
      {
	if(i == j)
	  a[i][j] = 1.0;
	else
	  a[i][j] = 0;
      }

  return ;
}
//====================================================================
void diag(double **a, int n, double val)
{

  for(int i = 0;i<n;i++)
    for(int j = 0;j<n;j++)
      {
	if(i == j)
	  a[i][j] = val;
	else
	  a[i][j] = 0;
      }

  return ;
}
//====================================================================
void zero(double **a, int m, int n)
{

  for(int i = 0;i < m;i++)
    for(int j = 0;j < n;j++)
      a[i][j] = 0.0;
  return ;
}
//====================================================================
void zero(double *a, int n)
{

  for(int i = 0;i < n;i++)
    a[i] = 0.0;
  return ;
}
//====================================================================
void multiply(double **a, double **b, int m, int n, int l, double **c)
{

  zero(c,m,n);
  for(int i = 0;i < m;i++)
    {
      for(int j = 0;j<n;j++)
	{
	  for(int k = 0;k<l;k++)
	    c[i][j] += a[i][k] * b[k][j];
	}
    }

  return;
}
//====================================================================
void multiply(double **a, double *b, int m, int n, double *c)
{

  zero(c,m);
  for(int i = 0;i < m;i++)
    {
      for(int j = 0;j<n;j++)
	c[i] += a[i][j] * b[j];
    }

  return;
}
//====================================================================
void multiply(double *b, double **a, int m, int n, double *c)
{

  zero(c,n);
  for(int i = 0;i < n;i++)
    {
      for(int j = 0;j<m;j++)
	c[i] += a[j][i] * b[j];
    }

  return;
}
//====================================================================
void multiply(double **a, double b, int m, int n, double **c)
{

  zero(c,m,n);
  for(int i = 0;i < m;i++)
    {
      for(int j = 0;j<n;j++)
	c[i][j]  = a[i][j] * b;
    }

  return;
}
//====================================================================
void multiply(double *a, double b, int n, double *c)
{


  zero(c,n);
  for(int i = 0;i < n;i++)
    c[i] = a[i] * b;

  return;
}
//====================================================================
void multiply(double **a, double val, int m, int n)
{

  for(int i = 0;i < m;i++)
    {
      for(int j = 0;j<n;j++)
	a[i][j]  = a[i][j] * val;
    }

  return ;
}
//====================================================================
void multiply(double *a, double b, int n)
{

  for(int i = 0;i < n;i++)
    a[i] = a[i] * b;

  return;
}
//====================================================================
double dotproduct(double *a, double *b, int n)
{

  double c;
  c = 0;

  for(int i = 0;i < n;i++)
    c += a[i] * b[i];

  return(c);
}
//====================================================================
void outerproduct(double *a, double *b, int n, double **c)
{

  for(int i = 0;i < n;i++)
    {
      for(int j = 0;j<n;j++)
	c[i][j] = a[i] * b[j];
    }

  return;
}
//====================================================================
void Transpose(double **a, int m, int n, double **b)
{

  for(int i = 0;i < m;i++)
    for(int j = 0; j < n;j++)
      b[j][i] = a[i][j];

  return;
}
//====================================================================
void add(double **a, double **b, int m, int n, double **c)
{

  for(int i= 0;i<m;i++)
    for(int j= 0;j<n;j++)
      c[i][j] = a[i][j] + b[i][j];

  return;
}
//====================================================================
void add(double **a, double **b, int m, int n)
{

  for(int i= 0;i<m;i++)
    for(int j= 0;j<n;j++)
      a[i][j] +=  b[i][j];

  return;
}
//====================================================================
void add(double *a, double *b, int n, double *c)
{

  for(int i= 0;i<n;i++)
    c[i] = a[i] + b[i];

  return;
}
//====================================================================
void add(double *a, double *b, int n)
{

  for(int i= 0;i<n;i++)
    a[i] +=  b[i];

  return;
}
//====================================================================
double add(double **a, int m, int n)
{

  double sum;

  sum = 0;
  for(int i= 0;i<m;i++)
    for(int j= 0;j<n;j++)
      sum +=  a[i][j];

  return(sum);
}
//====================================================================
double add(double *a, int n)
{

  double sum;
  sum = 0;
  for(int i= 0;i<n;i++)
    sum += a[i];

  return(sum);
}
//====================================================================
void sub(double **a, double **b, int m, int n, double **c)
{

  for(int i= 0;i<m;i++)
    for(int j= 0;j<n;j++)
      c[i][j] = a[i][j] - b[i][j];

  return;
}
//====================================================================
void sub(double **a, double **b, int m, int n)
{

  for(int i= 0;i<m;i++)
    for(int j= 0;j<n;j++)
      a[i][j] -= b[i][j];

  return;
}
//====================================================================
void sub(double *a, double *b, int n, double *c)
{

  for(int i= 0;i<n;i++)
    c[i] = a[i] - b[i];

  return;
}
//====================================================================
void sub(double *a, double *b, int n)
{

  for(int i= 0;i<n;i++)
    a[i] -=  b[i];

  return;
}
//====================================================================
void divide(double **a, double b, int m, int n, double **c)
{

  for(int i= 0;i<m;i++)
    for(int j= 0;j<n;j++)
      c[i][j] = a[i][j] / b;

  return;
}
//====================================================================
void divide(double **a, double b, int m, int n)
{

  for(int i= 0;i<m;i++)
    for(int j= 0;j<n;j++)
      a[i][j] /= b;

  return;
}
//====================================================================
void divide(double *a, double b, int n, double *c)
{

  for(int i= 0;i<n;i++)
    c[i] = a[i]/b;

  return;
}
//====================================================================
void divide(double *a, double b, int n)
{

  for(int i= 0;i<n;i++)
    a[i] /=  b;

  return;
}
//====================================================================
void display(double **a, int m, int n)
{


  for(int i = 0;i<m;i++)
    {
      for(int j = 0;j<n;j++)
	cout<<a[i][j] << "\t";
      cout<<endl;
    }

  return ;
}
//====================================================================
void display(double *a, int n,int mode)
{


  for(int i = 0;i<n;i++)
    {
      if (mode == 0)
	cout<<a[i] << "\t";
      else if(mode == 1)
	cout<<a[i] << "\n";
    }
  cout<<endl;

  return ;
}
//====================================================================
double min(double **a, int m, int n)
{

  double val;

  val = a[0][0];
  for(int i = 0;i<m;i++)
    for(int j = 0;j<n;j++)
      {
	if(a[i][j] < val)
	  val = a[i][j];
      }

  return (val);

}
//====================================================================
double min(double *a, int n)
{

  double val;

  val = a[0];
  for(int i = 0;i<n;i++)
    {
    if(a[i] < val)
      val= a[i];
    }

  return(val);
}
//====================================================================
double max(double **a, int m, int n)
{

  double val;

  val = a[0][0];
  for(int i = 0;i<m;i++)
    for(int j = 0;j<n;j++)
      {
	if(a[i][j] > val)
	  val = a[i][j];
      }

  return (val);

}
//====================================================================
double max(double *a, int n)
{

  double val;

  val = a[0];
  for(int i = 0;i<n;i++)
    {
    if(a[i] > val)
      val= a[i];
    }

  return(val);
}

//====================================================================
void assign(double *a, int n, double *b)
{

  for(int i = 0;i<n;i++)
    b[i] = a[i];
}
//====================================================================
void assign(double **a, int m, int n, double **b)
{

  for(int i = 0;i<m;i++)
    for(int j = 0;j<n;j++)
      b[i][j] = a[i][j];
}
//====================================================================
//EOF
