
#include <iostream>
#include<cmath>
#define PI 3.14159265

using namespace std;

//To Store the global x,y,z coordinates
typedef struct{
double x;
double y;
double z;
}Matrix3f;

//To store the joint angles
typedef struct{
double t1;
double t2;
double t3;
double t4;
double t5;
double t6;
double t7;
}Angles3;

// To subtract two matrices
Matrix3f sub(Matrix3f a,Matrix3f b)
{
    Matrix3f c;
    c.x=a.x-b.x;
    c.y=a.y-b.y;
    c.z=a.z-b.z;
    return c;
}

//To take cross product of the two matrices
Matrix3f cross(Matrix3f a,Matrix3f b)
{
    Matrix3f c;
    c.x=a.y*b.z-a.z*b.y;
    c.y=a.z*b.x-a.x*b.z;
    c.z=a.x*b.y-a.y*b.x;
    return c;
}

//To get the magnitude of a vector
float mod(Matrix3f a)
{
    return sqrt(pow(a.x,2)+pow(a.y,2)+pow(a.z,2));
}

//To take do product
float dot(Matrix3f a,Matrix3f b)
{
    return a.x*b.x+a.y*b.y+a.z*b.z;
}

//To get angles between 3 vectors
Angles3 calculate_joint(Matrix3f j0,Matrix3f j1,Matrix3f j2,Matrix3f j3,Matrix3f j4)
{
	int theta1,theta2,theta3,theta4,theta5,theta6;
	Angles3 ang; 
	ang.t1=atan2(mod(cross(sub(j2,j1),sub(j0,j1))),dot(sub(j2,j1),sub(j0,j1)))*180/PI;
	if(ang.t1>90)
		ang.t1=-180+ang.t1;
	ang.t2=atan2(mod(cross(sub(j4,j3),sub(j2,j3))),dot(sub(j4,j3),sub(j2,j3)))*180/PI;
	if(ang.t2>90)
		ang.t2=-180+ang.t2;
	ang.t3=atan2(mod(cross(sub(j3,j2),sub(j1,j2))),dot(sub(j3,j2),sub(j1,j2)))*180/PI;
	if(ang.t3>90)
		ang.t3=-180+ang.t3;
	return ang;
}

