#ifndef _REALPC_
#define _REALPC_

#include<constants.h>
#include<PCube.h>
#include <m5apiw32.h>

//======================================================




class RealPCube:public PCube
{

 private:

  int m_uDevNo;
  int* m_uvMod;

  float* m_vTh;

  float* m_vThMax;
  float* m_vThMin;

  float* m_vThdotMax;

  float* m_vhomevel;
  float* m_vRampvel;
  float* m_vRampacc;

  ulong *m_lvState;


  void CHECK_ERROR(int ret)const;

 public:

  RealPCube(const int& DevNo);
  ~RealPCube();


  void move_home();
  void check_move_home();
  void Move_module2home(const int& modID)const;

  void ManipulatorStop()const;
  void Robot_close()const;

  void Check_MovePosition(const float* const vTh);
  void MovePosition(const float* const vTh);
  void Move_module_pos(const int& mod, const float& Th)const ;

  void MoveVelocity(const float* const Thdot)const;

  void read_joint_angles(float* const vTh);
  void read_joint_velocity(float* const vThdot)const;


  void check_velocity(const float* const vThdot, float* const vThdotLimit)const;
  void check_angle(const float* const vTh, float* const vThLimit)const;


  void getJointAngleLimit(float* const vThMax, float* const vThMin);

  void reset();


  void check_moveStep(const float* const vTh, const long int& sTime);
  void moveStep(const float* const vTh, const long int& sTime);


};

//=======================================================



#endif


//===================================================================
//EOF